// auto generated by go tool dist

// On Linux systems, what we call 0(GS) and 4(GS) for g and m
// turn into %gs:-8 and %gs:-4 (using gcc syntax to denote
// what the machine sees as opposed to 8l input).
// 8l rewrites 0(GS) and 4(GS) into these.
//
// On Linux Xen, it is not allowed to use %gs:-8 and %gs:-4
// directly.  Instead, we have to store %gs:0 into a temporary
// register and then use -8(%reg) and -4(%reg).  This kind
// of addressing is correct even when not running Xen.
//
// 8l can rewrite MOVL 0(GS), CX into the appropriate pair
// of mov instructions, using CX as the intermediate register
// (safe because CX is about to be written to anyway).
// But 8l cannot handle other instructions, like storing into 0(GS),
// which is where these macros come into play.
// get_tls sets up the temporary and then g and r use it.
//
// Another wrinkle is that get_tls needs to read from %gs:0,
// but in 8l input it's called 8(GS), because 8l is going to
// subtract 8 from all the offsets, as described above.
//
// The final wrinkle is that when generating an ELF .o file for
// external linking mode, we need to be able to relocate the
// -8(r) and -4(r) instructions. Tag them with an extra (GS*1)
// that is ignored by the linker except for that identification.
#define	get_tls(r)	MOVL 8(GS), r
#define	g(r)	-8(r)(GS*1)
#define	m(r)	-4(r)(GS*1)
#define const_Gidle 0
#define const_Grunnable 1
#define const_Grunning 2
#define const_Gsyscall 3
#define const_Gwaiting 4
#define const_Gmoribund_unused 5
#define const_Gdead 6
#define const_Pidle 0
#define const_Prunning 1
#define const_Psyscall 2
#define const_Pgcstop 3
#define const_Pdead 4
#define const_true 1
#define const_false 0
#define const_PtrSize 4
#define const_StackCacheSize 32
#define const_StackCacheBatch 16
#define const_sizeofLock 4
#define const_sizeofNote 4
#define const_sizeofString 8
#define const_sizeofFuncVal 4
#define const_sizeofIface 8
#define const_sizeofEface 8
#define const_sizeofComplex64 8
#define const_sizeofComplex128 16
#define const_sizeofSlice 12
#define const_sizeofGobuf 24
#define gobuf_sp 0
#define gobuf_pc 4
#define gobuf_g 8
#define gobuf_ret 12
#define gobuf_ctxt 16
#define gobuf_lr 20
#define const_sizeofGCStats 40
#define const_sizeofWinCall 24
#define wincall_fn 0
#define wincall_n 4
#define wincall_args 8
#define wincall_r1 12
#define wincall_r2 16
#define wincall_err 20
#define const_sizeofSEH 8
#define seh_prev 0
#define seh_handler 4
#define const_sizeofWinCallbackContext 12
#define cbctxt_gobody 0
#define cbctxt_argsize 4
#define cbctxt_restorestack 8
#define const_sizeofG 160
#define g_stackguard0 0
#define g_stackbase 4
#define g_panicwrap 8
#define g_selgen 12
#define g_defer 16
#define g_panic 20
#define g_sched 24
#define g_syscallstack 48
#define g_syscallsp 52
#define g_syscallpc 56
#define g_syscallguard 60
#define g_stackguard 64
#define g_stack0 68
#define g_stacksize 72
#define g_alllink 76
#define g_param 80
#define g_status 84
#define g_goid 88
#define g_waitreason 96
#define g_schedlink 100
#define g_ispanic 104
#define g_issystem 105
#define g_isbackground 106
#define g_preempt 107
#define g_raceignore 108
#define g_m 112
#define g_lockedm 116
#define g_sig 120
#define g_writenbuf 124
#define g_writebuf 128
#define g_dchunk 132
#define g_dchunknext 136
#define g_sigcode0 140
#define g_sigcode1 144
#define g_sigpc 148
#define g_gopc 152
#define g_racectx 156
#define g_end 160
#define const_sizeofM 4748
#define m_g0 0
#define m_moreargp 4
#define m_morebuf 8
#define m_moreframesize 32
#define m_moreargsize 36
#define m_cret 40
#define m_procid 44
#define m_gsignal 52
#define m_tls 56
#define m_mstartfn 72
#define m_curg 76
#define m_caughtsig 80
#define m_p 84
#define m_nextp 88
#define m_id 92
#define m_mallocing 96
#define m_throwing 100
#define m_gcing 104
#define m_locks 108
#define m_dying 112
#define m_profilehz 116
#define m_helpgc 120
#define m_spinning 124
#define m_fastrand 128
#define m_ncgocall 132
#define m_ncgo 140
#define m_cgomal 144
#define m_park 148
#define m_alllink 152
#define m_schedlink 156
#define m_machport 160
#define m_mcache 164
#define m_stackinuse 168
#define m_stackcachepos 172
#define m_stackcachecnt 176
#define m_stackcache 180
#define m_lockedg 308
#define m_createstack 312
#define m_freglo 440
#define m_freghi 504
#define m_fflag 568
#define m_locked 572
#define m_nextwaitm 576
#define m_waitsema 580
#define m_waitsemacount 584
#define m_waitsemalock 588
#define m_gcstats 592
#define m_racecall 632
#define m_needextram 633
#define m_waitunlockf 636
#define m_waitlock 640
#define m_settype_buf 644
#define m_settype_bufsize 4740
#define m_seh 4744
#define m_end 4748
#define const_sizeofP 120
#define p_key 0
#define p_id 4
#define p_status 8
#define p_link 12
#define p_schedtick 16
#define p_syscalltick 20
#define p_m 24
#define p_mcache 28
#define p_runq 32
#define p_runqhead 36
#define p_runqtail 40
#define p_runqsize 44
#define p_gfree 48
#define p_gfreecnt 52
#define p_pad 56
#define const_LockExternal 1
#define const_LockInternal 2
#define const_sizeofStktop 52
#define const_sizeofSigTab 8
#define const_SigNotify 1
#define const_SigKill 2
#define const_SigThrow 4
#define const_SigPanic 8
#define const_SigDefault 16
#define const_SigHandling 32
#define const_SigIgnored 64
#define const_sizeofFunc 36
#define const_sizeofItab 20
#define const_Windows 0
#define const_sizeofTimers 28
#define const_sizeofTimer 32
#define const_sizeofLFNode 8
#define const_sizeofParFor 80
#define const_sizeofCgoMal 8
#define const_sizeofDebugVars 12
#define const_Structrnd 4
#define const_AMEM 0
#define const_AMEM0 1
#define const_AMEM8 2
#define const_AMEM16 3
#define const_AMEM32 4
#define const_AMEM64 5
#define const_AMEM128 6
#define const_ANOEQ 7
#define const_ANOEQ0 8
#define const_ANOEQ8 9
#define const_ANOEQ16 10
#define const_ANOEQ32 11
#define const_ANOEQ64 12
#define const_ANOEQ128 13
#define const_ASTRING 14
#define const_AINTER 15
#define const_ANILINTER 16
#define const_ASLICE 17
#define const_AFLOAT32 18
#define const_AFLOAT64 19
#define const_ACPLX64 20
#define const_ACPLX128 21
#define const_Amax 22
#define const_sizeofAlg 16
#define const_HashRandomBytes 32
#define const_sizeofDefer 28
#define const_sizeofDeferChunk 8
#define const_sizeofPanic 20
#define const_sizeofStkframe 32
#define const_UseSpanType 1
#define const_thechar 56
#define const_BigEndian 0
#define const_CacheLineSize 64
#define const_RuntimeGogoBytes 64
#define const_PCQuantum 1
#define const_PageShift 12
#define const_PageSize 4096
#define const_PageMask 4095
#define const_NumSizeClasses 61
#define const_MaxSmallSize 32768
#define const_FixAllocChunk 16384
#define const_MaxMHeapList 256
#define const_HeapAllocChunk 1048576
#define const_MHeapMap_Bits 20
#define const_MaxGcproc 8
#define const_sizeofMLink 4
#define const_sizeofFixAlloc 32
#define const_sizeof_1_ 20
#define const_sizeofMStats 3468
#define const_sizeofMCacheList 8
#define const_sizeofMCache 752
#define const_MTypes_Empty 0
#define const_MTypes_Single 1
#define const_MTypes_Words 2
#define const_MTypes_Bytes 3
#define const_sizeofMTypes 8
#define const_MSpanInUse 0
#define const_MSpanFree 1
#define const_MSpanListHead 2
#define const_MSpanDead 3
#define const_sizeofMSpan 60
#define const_sizeofMCentral 132
#define const_sizeof_2_ 196
#define const_sizeofMHeap 27988
#define const_FlagNoScan 1
#define const_FlagNoProfiling 2
#define const_FlagNoGC 4
#define const_FlagNoZero 8
#define const_FlagNoInvokeGC 16
#define const_TypeInfo_SingleObject 0
#define const_TypeInfo_Array 1
#define const_TypeInfo_Chan 2
#define const_DebugTypeAtBlockEnd 0
#define const_StackSystem 0
#define const_StackExtra 2048
#define const_StackMin 8192
#define const_FixedStack 8192
#define const_StackBig 4096
#define const_StackGuard 256
#define const_StackSmall 128
#define const_StackLimit 128
#define const_StackTop 96
#define const_raceenabled 0
#define const_sizeofType 32
#define const_sizeofMethod 24
#define const_sizeofUncommonType 20
#define const_sizeofIMethod 12
#define const_sizeofInterfaceType 44
#define const_sizeofMapType 48
#define const_sizeofChanType 40
#define const_sizeofSliceType 36
#define const_sizeofFuncType 60
#define const_sizeofPtrType 36
#define const_sizeofSched 96
#define const_MaxGomaxprocs 256
#define const_sizeofCgoThreadStart 12
#define const_sizeof_3_ 412
#define const_sizeofPdesc 24
#define GOEXPERIMENT ""
